CON
	_xinfreq		= 5_000_000			' Quartz is 5MHz
	_clkmode		= xtal1 + pll16x		' System clock is 80MHz

#define DracBladeProp

	SYNC_W			= 6*16
	VIDEO_W			= 320
	VIDEO_H			= 480
	CHAR_W			= 40
	CHAR_H			= 20
	FONT_W			= 8
	FONT_H			= 12
	FRONT_PORCH		= 31
	VSYNC_ROWS		= 2
	BOTTOM_PORCH		= 11

	do_pin			= 15
	clk_pin			= 14
	di_pin			= 13
	cs_pin			= 12

OBJ
	vgavid	: "vgavid"
	vgagen	: "vgagen"

VAR
	long	seed
	long	x
	long	y

PUB main
	vgavid.start(@sync, @pixmem0, @colmem0, 16)

	waitcnt(6 * clkfreq + cnt)

	vgagen.start(@sync, @pixmem0, @colmem0)

	seed := 1
	repeat
		repeat y from 0 to CHAR_H-1
			repeat x from 0 to CHAR_W-1
				framebuff[y * CHAR_W + x] := rnd
				waitcnt(1_000_000 + cnt)

PRI rnd
	seed := seed * 1103515245 + 12345 + CNT / 7777
	return seed

DAT
pixmem0		long	$01234567[CHAR_W/2*FONT_H]		' first row of pixels
pixmem1		long	$aa3300ff[CHAR_W/2*FONT_H]		' second row of pixels
pixmem2		long	$aa55aa55[CHAR_W/2*FONT_H]		' second row of pixels
colmem0		long	$13233343[CHAR_W/2]			' first row of colors
colmem1		long	$e3d3c3b3[CHAR_W/2]			' second row of colors
colmem2		long	$03430343[CHAR_W/2]			' second row of colors
sync		long	0
framebuff	word	0[CHAR_W*CHAR_H]
